#include <TypeToBytes.mqh> // https://www.mql5.com/ru/code/16280

class DATA_STRING
{
public:
  template <typename T>
  static string ToString( const T &Data )
  {
    static uchar Key[];
    uchar Result[];

    ::CryptEncode(CRYPT_BASE64, _R(Data).Bytes, Key, Result);

    return(::CharArrayToString(Result));
  }

  template <typename T>
  static string ToString( const T &Data[] )
  {
    static uchar Key[];
    uchar Result[];

    ::CryptEncode(CRYPT_BASE64, _R(Data).Bytes, Key, Result);

    return(::CharArrayToString(Result));
  }

  template <typename T>
  static T FromString( const string Str )
  {
    static uchar Key[];
    uchar Result[];
    uchar Data[];

    ::ArrayCopy(Data, _R(Str).Bytes, 0, 0, ::StringLen(Str));
    ::CryptDecode(CRYPT_BASE64, Data, Key, Result);

    T Res = {0};
    _W(Res) = Result;

    return(Res);
  }

  template <typename T>
  static int FromString( const string Str, T &Array[] )
  {
    static uchar Key[];
    uchar Result[];
    uchar Data[];

    ::ArrayCopy(Data, _R(Str).Bytes, 0, 0, ::StringLen(Str));
    ::CryptDecode(CRYPT_BASE64, Data, Key, Result);

    return(_ArrayCopy(Array, Result) / sizeof(T));
  }
};